

;                       ######  ##      ######  ##  ##
;                       ##      ##      ##      # ## #
;                       ####    ##      ####    #    #
;                       ##      ##      ##      #    #
;                       ######  ######  ######  #    #
;
;                                  By Kaid
;                              kaid@excite.fr
;                       ******************************
;                       Version 2.0            09/1999




.INCLUDE USGARD.H
.ORG 0
TitreUsgard:
.DB "Elem 2.0",0

;                           * Dfinitions *
;                           ***************                      

;* Variables *
POS_MENU      = GRAPH_MEM       ;Position dans le menu

SAISIE        = GRAPH_MEM+1     ;Buffer de saisie
TAILLE_SAISIE = GRAPH_MEM+14    ;Taille maximale de la saisie

ADR_DERNIER   = GRAPH_MEM+15    ;Adresse du dernier lment dans le tableau
TAB_ADR       = GRAPH_MEM+17    ;Le tableau d'adresses vers les lments 


;* Dfinition de codes ASCII *

F_DTE         = $D7             ;Flche pour le menu
ALP_CURS      = 218             ;'[A]' 



;                           * Programme *
;                           *************                      


;* Prparation de l'cran *

        ROM_CALL(CLEARLCD)      ;On l'efface

        LD HL,$0700             ;
        LD (CURSOR_ROW),HL      ;
        LD HL,&Str_Titre        ;
        ROM_CALL(D_ZT_STR)      ;Affiche le titre

        LD DE,$3928             ;
        LD (CURSOR_X),DE        ;
        ROM_CALL(D_ZM_STR)      ;Affiche l'adresse e-mail

        LD HL,$0146             ;
        LD (CURSOR_X),HL        ;
        LD HL,&TitreUsgard+5    ;
        ROM_CALL(D_ZM_STR)      ;Affiche la version

        LD A,2                  ;Initialise la position dans le menu
        LD (POS_MENU),A


        CALL &Cree_Tab_Adr      ;Cre le tableau d'adresses des lments



; * Affiche le menu *

DessineMenu:

        LD HL,&Menu             ;On affiche les 4 lignes correspondantes 
        LD DE,$100A             ; au choix disponibles dans le menu
        LD B,4
        CALL &Aff_N_Lgn

;                       * Boucle principale *
;                       *********************

BoucleMenu:

        LD DE,POS_MENU          ;DE pointe sur la position dans le menu

        LD A,F_DTE              ;Affiche la "flche"
        CALL &Aff_Car_Menu

        CALL &AttendTouche      ;Attend la pression d'une touche

        PUSH AF 
        LD A,$20                ;Efface la "flche"
        CALL &Aff_Car_Menu
        POP AF

        CP K_UP
        JR Z,Menu_Monte         ;On "monte" dans le menu

        CP K_DOWN
        JR Z,Menu_Descend       ;On "descend" dans le menu

        CP K_ENTER              ;Si la touche n'est pas [ENTER], on attend
        JR NZ,BoucleMenu        ; la saisie d'une autre touche


; * On gre le choix de l'utilisateur *
Menu_Entree:

        LD A,(DE)               ;A=Position Y du choix

        CP 5                    ;Y=5 -> Quitter
        JR NZ,Ne_pas_quitter

        ROM_CALL(CLEARTEXT)     ;Pour effacer la mmoire graphique
        RET                     ;On quitte Elem


Ne_pas_quitter:
        CALL &Eff_Ecran         ;Efface la partie "non-fixe" de l'cran                

        CP 4                    ;Y=4 -> Parcours
        CALL Z,&ParcoursListe

        CP 3                    ;Y=3 -> Recherche par le nom
        CALL Z,&Rech_nom

        CP 2                    ;Y=2 -> Recherche par le symbole
        CALL Z,&Rech_symb


        CALL &Eff_Ecran         ;Efface la partie "non-fixe" de l'cran                
        JR DessineMenu          ;On redessine le menu



; * Pour descendre d'un choix dans le menu *
Menu_Descend:

        LD A,(DE)               ;A=Position dans le menu

        INC A                   ;On l'incrmente

        CP 6                    ;Si nous sommes aprs le dernier choix, on
        JR Z,BoucleMenu         ; laisse POS_MENU inchang

        JR Menu_Met_A_Jour      ;On saute pour mettre POS_MENU  jour


; * Pour monter d'un choix dans le menu *
Menu_Monte:
        LD A,(DE)               ;A=Position dans le menu

        DEC A                   ;On la dcrmente

        CP 1                    ;Si nous sommes avant le premier choix, on
        JR Z,BoucleMenu         ; laisse POS_MENU inchang

Menu_Met_A_Jour:
        LD (DE),A               ;Met  jour POS_MENU
        JR BoucleMenu           ;On boucle sur le menu
        





;                              * Procdures *
;                              ************** 



; * Recherche d'un lment par son symbole *
Rech_symb:

        LD A,2                  ;Taille maximum de la saisie
        LD HL,&Menu             ;Pointe sur la chaine indiquant le type de recherche
        CALL &Debut_Recherche   ;
        RET NZ                  ;Si Z!=0, alors l'utilisateur  appuyer sur [EXIT]

        CALL &Recherche_Symb    ;Recherche le symbole correspondant au buffer
                                ; de saisie

        CALL &Fin_Recherche     ;Fin de la recherche
        CP K_EXIT               ;Si l'utilisateur n'a appuy sur [EXIT], on
        JR NZ,Rech_symb         ;recherche un autre lment
        RET
       

; * Recherche d'un lment par son symbole *
Rech_nom:

        LD A,12                 ;Taille maximum de la saisie
        LD HL,&Menu_2           ;Pointe sur la chaine indiquant le type de recherche
        CALL &Debut_Recherche
        RET NZ                  ;Si Z!=0, alors l'utilisateur  appuyer sur [EXIT]

        CALL &Recherche_Nom     ;Recherche le symbole correspondant au buffer
                                ; de saisie

        CALL &Fin_Recherche     ;Fin de la recherche
        CP K_EXIT               ;Si l'utilisateur n'a appuy sur [EXIT], on
        JR NZ,Rech_nom          ;recherche un autre lment
                                ; autre touche que [EXIT]
        RET


; * Saisie d'un chaine de caractre de <TAILLE_SAISIE> caractres maximum
;   vers SAISIE *

Saisie:
; * Vide le buffer de saisie *

        LD HL,SAISIE            ;HL pointe sur le buffer de saisie
        PUSH HL                 ;Sauve HL pour aprs
        LD BC,13-1              ;(Nombre de caractres+1)-1
        CALL OTH_CLEAR          ;

        POP DE                   ;DE pointe sur le buffer de saisie
        
; * Boucle principale *
SaisieCar:

        LD HL,$0304             ;Affiche le buffer de saisie
        LD (CURSOR_ROW),HL
        LD HL,SAISIE
        ROM_CALL(D_ZT_STR)

        LD A,ALP_CURS           ;On affiche le '[A]' ainsi qu'un espace
        ROM_CALL(TX_CHARPUT)
        LD A,$20
        ROM_CALL(TX_CHARPUT)

Pres_Touche:

; * Gestion de la saisie des caractres *

        CALL &AttendTouche      ;Attend la pression d'une touche

        CP K_ENTER              ;[ENTER] presse ?
        JR Z,Fin_Saisie         ; C'est la fin de la saisie

        CP K_DEL                ;[DEL] presse ?
        JR Z,Efface             ; On efface un caractre

        CP K_EXIT               ;[EXIT] presse ?
        JR Z,Abandonne          ; On quitte la saisie

        LD HL,&Touches          ;HL pointe sur le code des touches
        LD BC,28                ;Nombre de touches dans la liste

        CPIR                    ;Recherche A dans (HL)

        LD A,C                  ;A=C (Position de la touche dans la liste)

        OR A                    ;A=0 ?
        JR Z,Pres_Touche        ;La touche est inconnue

        ADD A,63                ;Transforme les codes des touches en lettres

	PUSH DE \ POP HL        ;HL=DE
        LD BC,SAISIE
        SBC HL,BC               ;HL-BC=Nombre de caractres saisis

        LD B,A                  ;On place dans B le caractre saisie
        LD A,(TAILLE_SAISIE)    ;A=Nombre de caractres maxi
        CP L                    ;
        JR Z,SaisieCar          ;Si A=L, la saisie est complte

        XOR A                   ;
        CP L                    ;Si A=L, 
        LD A,B                  ;   (On restaure le caractre saisie)
        JR Z,Premier_car        ;l'utilisateur saisie le 1 caractre

        ADD A,32                ;Ajoute 32 au caractre (MAJ->min)

Premier_car:

        LD (DE),A               ;Place le caractre dans la chaine de saisie
        INC DE                  ;Pointe sur le caractre suivant

        JR SaisieCar            ;Boucle pour continuer la saisie

Efface:
; * Effacement d'un caractre * 

        LD HL,SAISIE            ;Si DE=HL, alors le buffer est vide
        CALL CP_HL_DE        
        JR Z,SaisieCar          ;S'ils sont gaux, il n'y a pas de saisie

        DEC DE                  ;Pointe sur le caractre prcdent
        XOR A
        LD (DE),A               ;Remplace le caractre par un espace dans la saisie

        JR SaisieCar            ;Boucle pour continuer la saisie

Fin_Saisie:

        LD HL,SAISIE+1          ;On teste si l'utilisateur  saisie plus
        CALL CP_HL_DE           ;d'un caractre
        JR NZ,plus_d_un_carac

        LD A,$20                ;On ajoute un espace pour avoir une saisie
        LD (DE),A               ; du type "H "
plus_d_un_carac:
        XOR A
        RET
       
Abandonne:
        LD A,1                  ;L'utilisateur  appuy sur [EXIT]
        RET




;* Permet de parcourir la liste, lment par lment *
ParcoursListe:

        LD HL,TAB_ADR+2         ;Pointe sur l'adresse du premier lment

P_AffFiche:

        PUSH HL
        CALL &Aff_Fiche         ;Affiche la fiche correspondante
        POP HL

P_PressTouche:
        CALL &AttendTouche      ;Attend la pression d'une touche        

        CP K_EXIT               ; [EXIT] presse ?
        RET Z                   ; -> On sort 

        CP K_UP                 ; [UP] presse ?
        JR Z,Monte_Elem         ; -> On passe  l'lment prcdent

        CP K_DOWN               ; [DOWN] presse ?
        JR Z,Descend_Elem       ; -> On passe  l'lment suivant

        CP K_LEFT               ; [LEFT] presse ?
        JR Z,Premier_Elem       ; -> On passe au premier lment

        CP K_RIGHT              ; [RIGHT] non presse ?
        JR NZ,P_PressTouche     ; -> On saisie une autre touche


; * Passage au dernier lment (Flche droite) *

        LD HL,ADR_DERNIER       ;HL pointe sur l'adresse du dernier lment
        CALL LD_HL_MHL          ; et l'on place cette adresse dans HL
        JR P_AffFiche           ;On affiche ses infos

; * Passage au premier lment (Flche gauche) *
Premier_Elem:
        LD HL,TAB_ADR+2         ;On se replace sur le premier lment
        JR P_AffFiche           ; et on affiche ses infos

; * Passage  l'lment suivant (Flche bas) *
Descend_Elem:


        PUSH HL \ POP DE        ;DE=HL
        INC HL \ INC HL         ;Adresse du prochain lment
        CALL &Adr_Prochain      ;Met dans HL la bonne adresse (DE ou HL)
        JR NZ,P_AffFiche        ;Nous ne sommes pas  l'extremit de la liste.

        JR P_PressTouche        ;On saisie une autre touche

; * Passage  l'lment prcdent (Flche haut) *
Monte_Elem:

        PUSH HL \ POP DE        ;DE=HL
        DEC HL \ DEC HL         ;Adresse de l'lment prcdant
        CALL &Adr_Prochain      ;Met dans HL la bonne adresse (DE ou HL)
        JR NZ,P_AffFiche        ;Nous ne sommes pas  l'extremit de la liste.

        JR P_PressTouche        ;On saisie une autre touche



; * Code ralis avant la recherche et la saisie *
Debut_Recherche:

        CALL &Eff_Ecran         ;Efface la partie "non-fixe" de l'cran

        LD DE,$101A             ;Affiche le type de recherche
        LD (CURSOR_X),DE
        ROM_CALL(D_ZM_STR)

        LD HL,TAILLE_SAISIE     ;Dfinie la taille maximum de la saisie;
        LD (HL),A               ;

        LD A,':'                
        ROM_CALL(M_CHARPUT)     ;Ajoute un ":" aprs le type de recherche

        CALL &Saisie            ;Ralise la saisie
        OR A                    ;Test le rsultat de cette dernire
        RET


; * Code ralis aprs la recherche *
Fin_Recherche:

        OR A                    ;Si A=0, l'lment n'a pas t trouv
        JR Z,Elem_non_trouve

        CALL &Aff_Fiche         ;Affiche la fiche de l'lment point par HL
        JR Fin_Recherche_Fin

Elem_non_trouve:

        LD HL,$0304             ;
        LD (CURSOR_ROW),HL      ;
        LD HL,&NonTrouve        ;
        ROM_CALL(D_ZT_STR)      ;Affiche "Non trouv"

Fin_Recherche_Fin:

        CALL &AttendTouche      ;Attend la pression d'une touche 
        RET
                                       


;                              * Fonctions *
;                              ************* 


; * Attend la pression d'une touche. *
;   Entre: X
;   Sortie: A =Code de la touche   

AttendTouche:
        PUSH HL                 ;On sauve HL car GET_KEY le modifie

AttendTouche_Boucle:
        CALL GET_KEY                    
        OR A                            
        JR Z,AttendTouche_Boucle        
        POP HL                  
        RET



; * Affiche <B> chaines verticalement *
;   Entre: B =Nombre de lignes
;           DE=Position initiale du curseur
;           HL=Pointe sur les chaines
;   Sortie: X

Aff_N_Lgn:
        LD (CURSOR_X),DE        ;On place le curseur        
        ROM_CALL(D_ZM_STR)      ;        

        LD A,D                  ;
        ADD A,8                 ;
        LD D,A                  ;D=D+8, soit la prochaine ligne

        DJNZ Aff_N_Lgn
        RET


;* Affiche un caractre devant une ligne du menu *
;   Entre: A =Caractre
;   Sortie: X


Aff_Car_Menu:

        PUSH AF                 ;Sauve A (Caractre du menu)

        LD A,(DE)
        LD L,A
        LD H,0                  ;HL=POS_MENU

        LD (CURSOR_ROW),HL

        POP AF
        ROM_CALL(TX_CHARPUT)
        RET


; * Convertie un nombre dcimal vers une chaine *
;   Entre: A =Nombre  convertir
;           B =Nombre de chiffres
;           DE=Pointe sur la FIN de la chaine de destination
;   Sortie: X


Decode_8bits:

        PUSH BC
        PUSH DE
        PUSH HL

        LD L,A \ LD H,0         ;HL=A

Decode_8bits_Boucle:

        CALL UNPACK_HL
        ADD A,$30
        LD (DE),A
        DEC DE
        DJNZ Decode_8bits_Boucle

        POP HL
        POP DE
        POP BC

        RET


; * Compare deux chaines termines par un 0 *. Renvoie 0 si elles sont
;   Entre: DE=Pointe sur la 1 chaine
;           HL=Pointe sur la 2 chaine
;   Sortie: A =0 si les chaines sont gales, 1 sinon.

StrCmp:
        PUSH DE                 ;On sauve DE

StrCmp_Boucle:
        LD A,(DE)               ;A contient un caractre de la 1 chaine

        CPI                     ;CP (HL) / INC HL
        JR NZ,Str_Diff          ;Si les caractres sont !=, les chaines aussi

        INC DE                  ;Pointe sur le prochain caractre de la 1 chaine

        OR A                    ;Si le caractre n'est pas nul, on n'est pas
        JR NZ,StrCmp_Boucle     ;  la fin de la chaine, on continue le test

        XOR A                   ;Les chaines sont gales
        JR Fin_StrCmp           ;Va  la fin de la routine

Str_Diff:
        LD A,1                  ;Les chaines sont diffrentes

Fin_StrCmp:
        POP DE
        RET


;* Efface la partie "non-fixe" de l'cran
;   Entre: X
;   Sortie: X

Eff_Ecran:

        PUSH HL
        LD HL,VIDEO_MEM+256
        LD BC,512-1
        CALL OTH_CLEAR
        POP HL
        RET


;* Cre dans TAB_ADR un tableau de pointeurs vers &Donnees *
;   Entre: X
;   Sortie: X
Cree_Tab_Adr:
                
   	LD DE,TAB_ADR           ;DE=Destination, le tableau d'adresses

        XOR A                   ;
        LD (DE),A \ INC DE      ;On signale tout d'abord le dbut de la liste
        LD (DE),A \ INC DE      ; par un pointeur NULL

        LD HL,&Donnees          ;HL=Source

Cree_Tab_Adr_Boucle:

        EX DE,HL                ;On change DE et HL
        LD (HL),E               ;On transfre l'adresse contenue dans DE
        INC HL                  ; vers HL
        LD (HL),D
        INC HL
        EX DE,HL                ;On change DE et HL

; * On se place aprs le nom de l'lment *
        XOR A                  
        LD BC,$FF
        CPIR
        INC HL \ INC HL         ;HL pointe sur la partie entire de la masse

        CP (HL)                 ;Si A=(HL), nous sommes  la fin de la liste
        JR NZ,Cree_Tab_Adr_Boucle ;Sinon, on peut continuer  construire le tableau

        PUSH DE                 ;Sauve la position actuelle
        DEC DE \ DEC DE         ;DE pointe maintenant sur le dernier lment
                                ; point

        LD HL,ADR_DERNIER       ;On va sauver cette adresse

        LD (HL),E               ;On transfre l'adresse contenue dans DE
        INC HL                  ; vers (HL)
        LD (HL),D

        POP HL
        XOR A                   ;
        LD (HL),A \ INC HL      ;On signale la fin de la liste
        LD (HL),A               ; par un pointeur NULL
        RET



; * Place dans HL l'adresse du prochain lment en vrifiant si nous ne
;   sommes pas au dbut/ la fin de la liste *
;   Entre: DE=Pointe sur l'ancienne adresse
;           HL=Pointe sur l'adresse voulue
;   Sortie: HL=Pointe sur la bonne adresse
Adr_Prochain:
        PUSH HL
        XOR A
        CPI
        JR NZ,PasFinLst

        CP (HL)
PasFinLst:
        POP HL
        RET NZ
        EX DE,HL
        RET


; * Incrmente HL deux fois et teste s'il pointe sur la fin de la liste *
;   Entre: HL
;   Sortie: HL+=2
TestFinLst:
        INC HL \ INC HL
        PUSH HL
        PUSH DE
        CALL LD_HL_MHL
        LD DE,0
        CALL CP_HL_DE           ;Ce CALL change le Zero Flag
        POP DE
        POP HL
        RET



; * Recherche d'un lment par son symbole *
;   Entre: X
;   Sortie: A = 1 si l'lment est trouv, 0 sinon

Recherche_Symb:

        LD HL,TAB_ADR+2         ;HL pointe sur le tableau de pointeurs

Recherche_Symb_Boucle:

        LD DE,(SAISIE)          ;DE=Le symbole saisie

        PUSH HL                 ;Sauve HL
        CALL LD_HL_MHL          ;HL=Adresse de l'lment
        CALL LD_HL_MHL          ;HL=Symbole de l'lment
        CALL CP_HL_DE
        POP HL

        JR Z,S_Elem_Trouve      ;Si DE=HL, l'lment est trouv

        CALL &TestFinLst        ;Teste si nous sommes  la fin de la liste
        JR NZ,Recherche_Symb_Boucle ;Non, on recherche encore

        XOR A                   ;Elment non trouv
        RET

S_Elem_Trouve:
        LD A,1                  ;Elment trouv
        RET



; * Recherche d'un lment par son nom *
;   Entre: X
;   Sortie: A = 1 si l'lment est trouv, 0 sinon

Recherche_Nom:

        LD DE,SAISIE            ;DE pointe sur le buffer de saisie
        LD HL,TAB_ADR+2         ;HL pointe sur le tableau de pointeurs

Recherche_Nom_Boucle:

        PUSH HL                 ;Sauve HL
        CALL LD_HL_MHL          ;HL=Adresse de l'lment
        INC HL \ INC HL         ;HL pointe sur le nom de l'lment

        CALL &StrCmp            ;On compare les chaines
        POP HL
        OR A                    ;Si elles sont gales, l'lment est trouv
        JR Z,N_Elem_Trouve

        CALL &TestFinLst        ;Teste si nous sommes  la fin de la liste
        JR NZ,Recherche_Nom_Boucle ;Non, on recherche encore

        XOR A                   ;Elment non trouv
        RET

N_Elem_Trouve:
        LD A,1                  ;Elment trouv
        RET


; * Affiche une fiche correspondante  un lment *
;   Entre: HL=Pointe sur l'adresse de l'lment
;   Sortie: X
Aff_Fiche:


        PUSH HL                 ;On sauve cette adresse pour plus tard

        CALL LD_HL_MHL          ;HL contient maitenant l'adresse de l'lment

        PUSH HL
        CALL &Eff_Ecran         ;Efface la partie "non-fixe" de l'cran                

        LD HL,&Legende          ;
        LD DE,$1008             ;
        LD B,4                  ;
        CALL &Aff_N_Lgn         ;On affiche les chaines "lgende"

        LD A,$10                ;On place le curseur        
        LD (CURSOR_Y),A

        POP HL

; * Affiche le symbole *

        LD B,2

Aff_Lettre_Symb:
        LD A,(HL)
        ROM_CALL(M_CHARPUT)
        INC HL
        DJNZ Aff_Lettre_Symb

; * Affiche le nom *
        LD DE,$1832
        LD (CURSOR_X),DE
        ROM_CALL(D_ZM_STR)

; * Dcode la masse molaire *

        LD A,(HL)
        LD BC,$032E             ;B=3 (Nb chiffres) et C='.'
        LD DE,SAISIE+2          ;Pointe sur la destination
        CALL &Aff_Fiche_Divers

        LD A,(HL)
        PUSH AF
        RES 7,A                 ;On "efface" le dcalage s'il existe
        LD BC,$0200             ;B=2 (Nb chiffres) et C=0
        LD DE,SAISIE+5          ;Pointe sur la destination
        CALL &Aff_Fiche_Divers


; * Dcode le numro atomique *

        POP AF                  ;Restaure A (Partie dcimale de la masse molaire)
        POP HL                  ;HL (Adresse de l'lment dans le tableau d'adresses)
        LD DE,TAB_ADR
        SBC HL,DE               ;HL=Nombre de mots entre le premier lment
                                ; et l'lment choisi
        SRL L                   ;L/2=Numro atomique (linaire)
        AND %10000000           ;Si le dernier bit est  1, l'lment se
        JR Z,NumAtoOk           ; trouve aprs les Lanthanes

        LD A,14                 ;On ajoute donc 14  son numro atomique

NumAtoOk:
        ADD A,L                 
        LD DE,SAISIE+8
        CALL &Aff_Fiche_Divers

; * Affiche la masse molaire et le numro atomique *
        LD DE,$2032
        LD HL,SAISIE
        CALL &Aff_N_Lgn

        RET



; * Place dans DE le nombre plac dans (HL) sur (B) chiffres. 
;   Ajoute  la fin de DE le caractre (C) et incrmente HL *
;   Entre: C =Caractre  placer aprs le nombre convertie 
;           DE=Pointe vers la fin de l'emplacement destin  stocker le nombre
;           HL=Pointe sur le nombre  convertir en dcimal
;   Sortie: DE++
;           HL++

Aff_Fiche_Divers:

        CALL &Decode_8bits

        INC DE
        LD A,C
        LD (DE),A
        INC HL
        RET



;                              * Variables *
;                              ************* 

; * Liste des touches correspondantes aux lettres de l'alphabet *
Touches .DB K_DOT
        .DB K_0
        .DB K_PLUS
        .DB K_3
        .DB K_2
        .DB K_1
        .DB K_MINUS
        .DB K_6
        .DB K_5
        .DB K_4
        .DB K_COMMA
        .DB K_STAR
        .DB K_9
        .DB K_8
        .DB K_7
        .DB K_SQUARE
        .DB K_SLASH
        .DB K_RIGHTPAR
        .DB K_LEFTPAR
        .DB K_EE
        .DB K_LN
        .DB K_RAISE
        .DB K_TAN
        .DB K_COS
        .DB K_SIN
        .DB K_LOG
        .DB K_DEL

; * Chaines *
Str_Titre .DB "ELEM",0
Str_EMail .DB "kaid@excite.fr",0

; * Choix du menu *
Menu      .DB "Search by symbol",0
Menu_2    .DB "Search by name",0
          .DB "See all elements",0
          .DB "Exit",0

NonTrouve .DB " Not found   ",0

Legende   .DB "Symbol :",0
          .DB "Name :",0
          .DB "Ato Mass :",0
          .DB "Ato Number :",0


; * On inclut les lments *
.INCLUDE "Elem_e.dat"
.END
